local pResurrect = LibStub("AceAddon-3.0"):NewAddon("pResurrect", "AceEvent-3.0", "AceHook-3.0")
local mousetarget

local classes = { ["DRUID"] = true, ["PALADIN"] = true, ["PRIEST"] = true, ["SHAMAN"] = true }
local spells = {
	[2006] = true,  -- Rank 1 Resurrection
	[2010] = true,  -- Rank 2 Resurrection
	[10880] = true,  -- Rank 3 Resurrection
	[10881] = true,  -- Rank 4 Resurrection
	[20770] = true,  -- Rank 5 Resurrection
	[25435] = true,  -- Rank 6 Resurrection
	[7328] = true,  -- Rank 1 Redemption
	[10322] = true,  -- Rank 2 Redemption
	[10324] = true,  -- Rank 3 Redemption
	[20772] = true,  -- Rank 4 Redemption
	[20773] = true,  -- Rank 5 Redemption
	[2008] = true,  -- Rank 1 Ancestral Spirit
	[20609] = true,  -- Rank 2 Ancestral Spirit
	[20610] = true,  -- Rank 3 Ancestral Spirit
	[20776] = true,  -- Rank 4 Ancestral Spirit
	[20777] = true,  -- Rank 5 Ancestral Spirit
	[20484] = true,  -- Rank 1 Rebirth
	[20739] = true,  -- Rank 2 Rebirth
	[20742] = true,  -- Rank 3 Rebirth
	[20747] = true,  -- Rank 4 Rebirth
	[20748] = true,  -- Rank 5 Rebirth
	[26994] = true,  -- Rank 6 Rebirth
}

function pResurrect:OnEnable()
	if(not classes[select(2, UnitClass("player"))]) then return end
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:Hooks()
end

function pResurrect:COMBAT_LOG_EVENT_UNFILTERED(_,_,event,playerGUID,_,_,_,_,_,spellID)
	local target = UnitName("target")
	if(playerGUID == UnitGUID("player")) then
		if(event == "SPELL_CAST_START") then
			if(spells[spellID]) then
				if(not UnitExists("target")) then target = mousetarget end
				SendChatMessage(pResurrectQuotes[math.random(#pResurrectQuotes)]:gsub("%%t", target), "SAY")
			end
		end
	end
end

function pResurrect:WorldFrameOnMouseDown(...)
	if(GameTooltipTextLeft1:IsVisible()) then
		local name = select(3, GameTooltipTextLeft1:GetText():find("^Corpse of (.+)$"))
		if name then
			mousetarget = name
		end
	end
	self.hooks[WorldFrame]["OnMouseDown"](...)
end

function pResurrect:Hooks()
	self:HookScript(WorldFrame, "OnMouseDown", "WorldFrameOnMouseDown")
end